use roxy_core::roxy::Parse;

#[derive(Debug, Default)]
pub struct TeraParser {
    pub tera: tera::Tera,
    context: tera::Context,
}

impl TeraParser {
    pub fn new(tera: tera::Tera, context: tera::Context) -> Self {
        Self { tera, context }
    }
}

impl Parse for TeraParser {
    fn parse(&mut self, path: &str, src: &[u8], dst: &mut Vec<u8>) -> std::io::Result<()> {
        // TODO: This error is a hack
        let err = |e: tera::Error| {
            println!("{e:?}");
            std::io::Error::new(std::io::ErrorKind::InvalidData, e.to_string())
        };
        let template = String::from_utf8_lossy(src).to_string();

        self.tera
            .add_raw_template(path, template.as_str())
            .map_err(err)?;

        self.tera.render_to(path, &self.context, dst).map_err(err)
    }
}

#[cfg(test)]
mod tests {
    #[test]
    fn it_works() {
    }
}
